<?
	require "{$_SERVER["DOCUMENT_ROOT"]}/phpsysleg/global.php";
	include ROOT_CLASSES . "cl_resolucao.php";

	$clResolucao = new resolucao;
	if ($_REQUEST["btnCancelar"]) {
		header("location:altera_resolucao.php?org={$_REQUEST["org"]}&num={$_REQUEST["num"]}&ano={$_REQUEST["ano"]}");
		exit;
	}
	
	if ($_REQUEST["btnSubmit"]) {
		$clResolucao->orgao->sigla = $_REQUEST["slSiglaOrgao"];

		if (!($_REQUEST["txtNumeroResolucao"]))
			$erro_numero_resolucao = "Informe o nmero da resoluo";
		elseif (!(is_numeric($_REQUEST["txtNumeroResolucao"])))
			$erro_numero_resolucao = "Informe o nmero da resoluo corretamente";
		else
			$erro_numero_resolucao = "";

		if (!($_REQUEST["txtAno"]))
			$erro_ano_resolucao = "Informe o ano da resoluo {$_REQUEST["txtAno"]}";
		elseif (!(is_numeric($_REQUEST["txtAno"])))
			$erro_ano_resolucao = "Informe o ano da resoluo corretamente";
		elseif (($_REQUEST["txtAno"] > date("y")) AND
				($_REQUEST["txtAno"] > date("Y")))
			$erro_ano_resolucao = "O ano deve ser menor que " . date("Y");
		else
			$erro_ano_resolucao = "";

		if (!($_REQUEST["txtFinalidade"]))
			$erro_finalidade = "Informe a finalidade da resoluo";
		else
			$erro_finalidade = "";

		if (!($_REQUEST["txtParagrafoIntroducao"]))
			$erro_paragrafo_intro = "Informe o pargrafo de introduo da resoluo";
		else
			$erro_paragrafo_intro = "";

		if (!($_REQUEST["txtData"]))
			$erro_data = "Informe a data da expedio da resoluo";
		else {
			list($dia, $mes, $ano) = explode("/", $_REQUEST["txtData"]);
			if (!(checkdate($mes, $dia, $ano)))
				$erro_data = "Data invlida. Voc deve informar a data no formato dia/ms/ano";
			elseif (mktime(0, 0, 0, $mes, $dia, $ano) > time())
				$erro_data = "A data deve ser anterior ao dia de hoje.";
			else
				$erro_data = "";
		}

		if (!($_REQUEST["txtAssinadoPor"]))
			$erro_assinado_por = "Informe o nome do assinante da resoluo";
		else
			$erro_assinado_por = "";

		if ((!($erro_salvar_sigla_orgao)) AND
			(!($erro_numero_resolucao)) AND
			(!($erro_ano_resolucao)) AND
			(!($erro_finalidade)) AND
			(!($erro_paragrafo_intro)) AND
			(!($erro_data)) AND
			(!($erro_assinado_por)))
		{
		// Se no tiver nenhum erro, preenche a classe.
			$clResolucao->num = $_REQUEST["txtNumeroResolucao"];
			$clResolucao->ano = $_REQUEST["txtAno"];
			$clResolucao->finalidade = $_REQUEST["txtFinalidade"];
			$clResolucao->parag_intro = $_REQUEST["txtParagrafoIntroducao"];
			$clResolucao->data = "$ano-$mes-$dia";
			$clResolucao->assinado_por = $_REQUEST["txtAssinadoPor"];
			$salvar_resolucao = $clResolucao->Alterar($_REQUEST["org"], $_REQUEST["num"], $_REQUEST["ano"]);
			if ($salvar_resolucao === TRUE) {
				header("location:altera_resolucao.php?org={$clResolucao->orgao->sigla}&num={$clResolucao->num}&ano={$clResolucao->ano}");
				exit;
			}
			elseif ($salvar_resolucao == 1062)
				$erro_salvar_resolucao = "J existe uma resoluo {$clResolucao->num}/{$clResolucao->ano} do orgo {$clResolucao->orgao->sigla} cadastrada</B><BR>";
			else
				echo $erro_salvar_resolucao = mysql_error();
		}
	}
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<HTML>
<HEAD>
<TITLE>Sysleg - Alterao da Resoluo</TITLE>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">
<SCRIPT>
	function AlteraOrgao() {
		window.open('altera_orgao.php', 'ALT_ORG', 'status=no, location=no, toolbar=no, menubar=no, scrollbars=no, height = 420, width = 240')
	}
</SCRIPT>

</HEAD>

<BODY>
<?
	include ROOT_TEMPLATE . "topo.php";
	include ROOT_TEMPLATE . "menuvazio.php";
	$clResolucao = new resolucao;
	$clResolucao->Ler($_REQUEST["org"], $_REQUEST["num"], $_REQUEST["ano"]);
?>
<FORM NAME="frmResolucao" METHOD="get" ACTION="altera_resolucao_cabeca.php">
<INPUT TYPE="HIDDEN" name="org" value="<? echo $_REQUEST["org"]; ?>">
<INPUT TYPE="HIDDEN" name="num" value="<? echo $_REQUEST["num"]; ?>">
<INPUT TYPE="HIDDEN" name="ano" value="<? echo $_REQUEST["ano"]; ?>">
	<P><B>Alterao de Resoluo</B></P>
	<P>Resoluo <? echo "{$clResolucao->orgao->sigla} {$clResolucao->num}/{$clResolucao->ano}"?></P>
	<FONT SIZE=2><?
	if ($erro_salvar_resolucao)
		echo "\n	<FONT COLOR=\"#FF0000\">$erro_salvar_resolucao</FONT><BR>\n";

	if ($erro_salvar_sigla_orgao)
		echo "<FONT COLOR=\"#FF0000\">$erro_salvar_sigla_orgao</FONT><BR>\n";?>
	<P>rgo Responsvel
	<SELECT NAME="slSiglaOrgao">
	<?
		$orgaos = $clResolucao->orgao->Listar();
		foreach ($orgaos as $orgao)
			echo "		<OPTION VALUE=\"{$orgao->sigla}\"" . ($_REQUEST["slSiglaOrgao"] == $orgao->sigla ? " SELECTED" : ($clResolucao->sigla == $orgao->sigla ? " SELECTED" : "")) . ">{$orgao->sigla}</OPTION>\n";
		?>
	</SELECT></P>
	<P><?
	if ($erro_numero_resolucao)
		echo "\n<FONT COLOR=\"#FF0000\">$erro_numero_resolucao</FONT><BR>";
	?>Nmero: <INPUT TYPE="text" NAME="txtNumeroResolucao"<?echo ($_REQUEST["txtNumeroResolucao"] ? " VALUE=\"{$_REQUEST["txtNumeroResolucao"]}\"" : " VALUE=\"{$clResolucao->num}\""); ?>></P>

	<P><?
	if ($erro_ano_resolucao)
		echo "\n<FONT COLOR=\"#FF0000\">$erro_ano_resolucao</FONT><BR>";
	?>Ano: <INPUT TYPE="text" NAME="txtAno"<? echo ($_REQUEST["txtAno"] ? " VALUE=\"{$_REQUEST["txtAno"]}\"" : " VALUE=\"{$clResolucao->ano}\"")?>></P>

	<P><?
	if ($erro_finalidade)
		echo "\n<FONT COLOR=\"#FF0000\">$erro_finalidade</FONT><BR>";
	?>Finalidade:<BR>
    <TEXTAREA NAME="txtFinalidade" COLS="100" ROWS="6" STYLE="font-size: 12px;font-family: verdana"><? echo ($_REQUEST["txtFinalidade"] ? $_REQUEST["txtFinalidade"] : $clResolucao->finalidade); ?></TEXTAREA></P>

	<P><?
	if ($erro_paragrafo_intro)
		echo "\n<FONT COLOR=\"#FF0000\">$erro_paragrafo_intro</FONT><BR>";
	?>Par&aacute;grafo de introdu&ccedil;&atilde;o:<BR>
    <TEXTAREA NAME="txtParagrafoIntroducao" COLS="100" ROWS="8" STYLE="font-size: 12px;font-family: verdana"><? echo ($_REQUEST["txtParagrafoIntroducao"] ? $_REQUEST["txtParagrafoIntroducao"] : $clResolucao->parag_intro); ?></TEXTAREA></P>

	<P><?
	if ($erro_data)
		echo "\n<FONT COLOR=\"#FF0000\">$erro_data</FONT><BR>";
	?>Data da resolu&ccedil;&atilde;o: <INPUT TYPE="text" NAME="txtData"<? echo ($_REQUEST["txtData"] ? " VALUE=\"{$_REQUEST["txtData"]}\"" : " VALUE=\"{$clResolucao->data}\""); ?>><FONT SIZE=1><B> Exemplo: 30/05/2004</B></FONT></P>

	<P><?
	if ($erro_assinado_por)
		echo "\n<FONT COLOR=\"#FF0000\">$erro_assinado_por</FONT><BR>";
	?>Responsvel (assinado por): <INPUT NAME="txtAssinadoPor" TYPE="text" SIZE="30"<? echo ($_REQUEST["txtAssinadoPor"] ? " VALUE=\"{$_REQUEST["txtAssinadoPor"]}\"" : " VALUE=\"{$clResolucao->assinado_por}\""); ?>></P>
	<INPUT STYLE="FONT-FAMILY: Verdana" TYPE="SUBMIT" VALUE="Salvar" NAME="btnSubmit"><INPUT STYLE="FONT-FAMILY: Verdana" TYPE="submit" VALUE="Cancelar" NAME="btnCancelar">
</FORM>
</FONT>

<? include ROOT_TEMPLATE . "rodape.php" ?>
</BODY>

</HTML>
