<?
session_start();
require "{$_SERVER["DOCUMENT_ROOT"]}/phpsysleg/global.php";
require ROOT_CLASSES . "cl_declaracao.php";
require_once ROOT_CLASSES . "cl_palavras.php";

if ($_REQUEST["btnSubmit"]) {
	for ($i = 1;$i <= 5;$i++) { // Rola as 5 declaraes da tela
		// Nomes dos componentes
		$textAf = "txtDec$i";
		$textNeg = "txtDecNeg$i";
        // Funo
		$palavras_chave = remove_virgulas_espacos($_REQUEST["txtPalavrasChave$i"]); // Retorna um array com cada palavra chave

        // Se tiver palavras chave, constri uma string, separada por vrgulas
		// Se estiverem todos preenchidos
		if ($_REQUEST[$textAf] AND $_REQUEST[$textNeg] /*AND $palavras_chave*/) {
            // Incia transao.
            // S commit se a declarao, as palavras-chave e os vnculos forem inseridos
			Transacao("BEGIN");

			// Insere a declarao no BD
			$clDeclaracao = new declaracao;
			$clDeclaracao->afirmativa = $_REQUEST[$textAf];
			$clDeclaracao->negativa = $_REQUEST[$textNeg];
			$salvar_declaracao = $clDeclaracao->Salvar();
			if ($salvar_declaracao === TRUE) {
				// Salva/l as palavras-chave e vincula cada uma delas.
				// Rola cada palavra, que ser um registro distinto.
				foreach ($palavras_chave as $index => $palavra) {
					$clPalavra = new palavra;
					$clPalavra->BuscarPorPalavra($palavra);
					if (!($clPalavra->codigo)) { // Se no encontrou registro da palavra
						// Salva a palavra num novo registro
						$clPalavra->palavra = $palavra;
						$salvar_palavras[$index] = $clPalavra->Salvar();
						if ($salvar_palavras[$index] === TRUE) {
							$salvar_vinculo[$index] = $clPalavra->VincularPalavraDeclaracao($clDeclaracao->codigo, $clPalavra->codigo);
							if ($salvar_vinculo[$index] === TRUE)
								$erro_salvar_vinculos = "";
							else
								$erro_salvar_vinculos = "Erro ao vincular palavra-chave  tabela.";
						}
					}
					else {
						$salvar_vinculo[$index] = $clPalavra->VincularPalavraDeclaracao($clDeclaracao->codigo, $clPalavra->codigo);
						if ($salvar_vinculo[$index] === TRUE)
							$erro_salvar_vinculos = "";
						else
							$erro_salvar_vinculos = "Erro ao vincular palavra chave  tabela.";
					}
				}
				unset($clPalavra);
			//}
				$teve_erro_salvar_palavra = FALSE;
				for ($j = 0;$j <= count($salvar_palavras) - 1; $j++) {
					if ($salvar_palavras[$j] === FALSE) {
						$teve_erro_salvar_palavra = TRUE;
						break;
					}
				}
				if (!($teve_erro_salvar_palavra)) {
					Transacao('COMMIT');
					$resultados[$i] = array(TRUE, "Declarao gravada com sucesso!");
				}
				else {
					Transacao('ROLLBACK');
					$resultados[$i] = array(FALSE, "Problema no salvamento das palavras-chave. Erro {$salvar_palavras[$j]} - palavra $j");
				}
			}
			else {
				Transacao('ROLLBACK');
				$resultados[$i] = array(FALSE, "Problema no salvamento da declarao. Erro $salvar_decalaracao");
			}
		}
		// Se tiver um preenchido, e um que no estiver, procura o erro.
		elseif ($_REQUEST[$textAf] OR $_REQUEST[$textNeg]) {
			if (!($_REQUEST[$textAf]))
				$resultados[$i] = array(FALSE, "Informe a forma afirmativa da declarao");
			elseif (!($_REQUEST[$textNeg]))
				$resultados[$i] = array(FALSE, "Informe a forma negativa da declarao");
			elseif (!($palavas_chave))
				$resultados[$i] = array(FALSE, "Informe pelo menos uma palavra-chave");
		}
		// Se no tiver nada preenchido, ignora declarao
		else
			$resultados[$i] = array(0,"");

	}
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<HTML>
<HEAD>
<TITLE>Sysleg - Declaraes</TITLE>
</HEAD>

<BODY><!-- OnLoad="javascript:self.moveTo(20,20)"-->
<? include ROOT_TEMPLATE . "topo.php";
   include ROOT_TEMPLATE . "menuvazio.php";?>

<FORM name="frmDecs" ACTION="cad_dec.php" METHOD="GET">
<P><B>Cadastro de Declaraes</B></P>

<P><FONT SIZE="1">Informe, nos respectivos campos, a forma afirmativa e a negativa das declaraes.<BR>
Informe as palavras-chave (no mnimo uma) que represente do que se trata a declarao. Separe-as por espaos ou vrgulas.</FONT><BR></P>
<P><FONT SIZE="2"><TABLE WIDTH="150">
<TR ALIGN=\"center\">
	<TD></TD>
	<TD><FONT SIZE=\"2\">Declarao Afirmativa</FONT></TD>
	<TD><FONT SIZE=\"2\">Declarao Negativa</FONT></TD>
	<TD><FONT SIZE=\"2\">Palavras-chave</FONT></TD>
</TR>
<?
	for ($i = 1;$i <= 5; $i++) {
		if ($_REQUEST["btnSubmit"])
			if ($resultados[$i][0] === 0)
				break;
			elseif ($resultados[$i][0] === FALSE)
				echo "
<TR>
	<TD ROWSPAN = 2>$i: </TD>
	<TD COLSPAN = 4><FONT COLOR=\"#FF0000\" SIZE=1>{$resultados[$i][1]}</FONT></TD>
</TR>
<TR>
	<TD><TEXTAREA NAME=\"txtDec$i\" COLS=\"45\" ROWS=\"3\" STYLE=\"font-size: 12px;font-family: verdana\">{$_REQUEST["txtDec$i"]}</TEXTAREA></TD>
	<TD><TEXTAREA NAME=\"txtDecNeg$i\" COLS=\"45\" ROWS=\"3\" STYLE=\"font-size: 12px;font-family: verdana\">{$_REQUEST["txtDecNeg$i"]}</TEXTAREA></TD>
	<TD><TEXTAREA NAME=\"txtPalavrasChave$i\" COLS=\"45\" ROWS=\"3\" STYLE=\"font-size: 12px;font-family: verdana\">{$_REQUEST["txtPalavrasChave$i"]}</TEXTAREA></TD>
</TR>";
			else // Se gravou corretamente
				echo "
<TR>
	<TD>$i: </TD>
	<TD COLSPAN = 4>{$resultados[$i][1]}</TD>
</TR>
";
		else // No teve submit
			echo "
<TR>
	<TD>$i: </TD>
	<TD><TEXTAREA NAME=\"txtDec$i\" COLS=\"45\" ROWS=\"3\" STYLE=\"font-size: 12px;font-family: verdana\"></TEXTAREA></TD>
	<TD><TEXTAREA NAME=\"txtDecNeg$i\" COLS=\"45\" ROWS=\"3\" STYLE=\"font-size: 12px;font-family: verdana\"></TEXTAREA></TD>
	<TD><TEXTAREA NAME=\"txtPalavrasChave$i\" COLS=\"45\" ROWS=\"3\" STYLE=\"font-size: 12px;font-family: verdana\"></TEXTAREA></TD>
</TR>";
	}
?>
</TABLE>
</P>
<P><?
	$mostre_submit = TRUE;
	if ($_REQUEST["btnSubmit"]) {
		$mostre_submit = FALSE;
		// Se nenhuma das declaraes tiver problema
		for ($i = 1;$i <= 5; $i++)
			if ($resultados[$i][0] === FALSE){
				$mostre_submit = TRUE;
				break;
			}
	}

	if ($mostre_submit)
		echo "<P><INPUT TYPE=\"submit\" NAME=\"btnSubmit\" VALUE=\"Salvar\"></P>";
	else
		echo "<A href=\"cad_dec.php\">Inserir mais cinco declaraes</A><BR>";
?>
<A href="cad_reg.php">Cadastrar regras</A><BR>
<A href="cad_res_corpo.php">Voltar para cadastro da resoluo</A><BR>
<A href="../../index.php">Voltar para administrao</A>
</FONT>
</FORM>
<?
	include ROOT_TEMPLATE. "rodape.php"
?>
</BODY>
</HTML>
