<?
session_start();
require "{$_SERVER["DOCUMENT_ROOT"]}/phpsysleg/global.php";
require ROOT_CLASSES . "cl_elemento.php";

function abre_novo_titulo() {
	$_SESSION["tit"]++;
	$_SESSION["cap"] = 0;
	$_SESSION["ses"] = 0;
	$_SESSION["sub"] = 0;
	$_SESSION["art"] = 0;
	$_SESSION["par"] = 0;
	$_SESSION["inc"] = 0;
	$_SESSION["ali"] = 0;
  	$_SESSION["itm"] = 0;
}

function abre_novo_capitulo() {
	$_SESSION["cap"]++;
	$_SESSION["ses"] = 0;
	$_SESSION["sub"] = 0;
	$_SESSION["art"] = 0;
	$_SESSION["par"] = 0;
	$_SESSION["inc"] = 0;
	$_SESSION["ali"] = 0;
  	$_SESSION["itm"] = 0;
}

function abre_nova_secao() {
	$_SESSION["ses"]++;
	$_SESSION["sub"] = 0;
	$_SESSION["art"] = 0;
	$_SESSION["par"] = 0;
	$_SESSION["inc"] = 0;
	$_SESSION["ali"] = 0;
  	$_SESSION["itm"] = 0;
} 

function abre_nova_subsecao() {
	$_SESSION["sub"]++;
	$_SESSION["art"] = 0;
	$_SESSION["par"] = 0;
	$_SESSION["inc"] = 0;
	$_SESSION["ali"] = 0;
  	$_SESSION["itm"] = 0;
}

function abre_novo_artigo() {
	$_SESSION["art"] = $_SESSION["prox_art"];
	$_SESSION["prox_art"]++;
	$_SESSION["par"] = 0;
	$_SESSION["inc"] = 0;
	$_SESSION["ali"] = 0;
  	$_SESSION["itm"] = 0;
};

function abre_novo_paragrafo() {
	$_SESSION["par"]++;
	$_SESSION["inc"] = 0;
	$_SESSION["ali"] = 0;
  	$_SESSION["itm"] = 0;
};

function abre_novo_inciso() {
	$_SESSION["inc"]++;
	$_SESSION["ali"] = 0;
  	$_SESSION["itm"] = 0;
};

function abre_nova_alinea() {
	$_SESSION["ali"]++;
  	$_SESSION["itm"] = 0;
};

function abre_novo_item() {
  	$_SESSION["itm"]++;
};

// Tanto o boto Salvar e prximo, quanto o Salvar e concludo efetuam o salvamento do elemento
// Se o boto Salvar e prximo for acionado, deve estar selecionado o prximo item
if ($_REQUEST["btnSubmit"]) {
	if (!($_REQUEST["radProxElem"]))
		$erro_prox_elemento = "Marque o boto correspondente ao prximo elemento da resoluo";
	else {
		$erro_prox_elemento = "";
		switch ($_REQUEST["radProxElem"]) {
			case "tit":
				abre_novo_titulo();
				break;
			case "cap":
				abre_novo_capitulo();
				break;
			case "ses":
				abre_nova_secao();
				break;
			case "sub":
				abre_nova_subsecao();
				break;
			case "art":		
				abre_novo_artigo();
				break;
			case "par":
				abre_novo_paragrafo();
				break;
			case "inc":
				abre_novo_inciso();
				break;
			case "ali":
				abre_nova_alinea();
				break;
			case "itm":
				abre_novo_item();
				break;
		}
		header("Location:cad_res_corpo.php");
		exit;
	}
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<head>
<title>SysLeg - Administra&ccedil;&atilde;o - Resolu&ccedil;&otilde;es</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>

<body>
<? include ROOT_TEMPLATE . "topo.php";
   include ROOT_TEMPLATE . "menuvazio.php";?>
<P><B>Cadastro de Elemento</B></P>
<FONT SIZE=2>
<form name="frmContinuar" method="get" action="cad_res_continuar_prox_nivel.php">
<?
    $clUltimoElemento = new elemento;
    $clUltimoElemento->Ler_por_codigo($_REQUEST["ultimo"]);
	$prox = "<P>Ultimo elemento cadastrado: <I>".$clUltimoElemento->HierarquiaExtenso()."</I></P>
<P>Selecione o prximo elemento:</P>\n<P>";
		
function insere_opcao($VALUE) {
	$captions = array("tit" => "Novo Ttulo (TTULO " . NumToRomano($_SESSION["tit"]+1) . ")", 
	                  "cap" => "Novo Captulo (CAPTULO " . NumToRomano($_SESSION["cap"]+1) . ")",
	                  "ses" => "Nova Seo (SEO " . NumToRomano($_SESSION["ses"]+1) . ")", 
	                  "sub" => "Nova Sub-seo (Sub-Seo " . NumToRomano($_SESSION["sub"]+1) . ")",
	                  "art" => "Novo Artigo (Art. " . ($_SESSION["prox_art"]) . ")",
	                  "par" => "Novo Pargrafo ( " . ($_SESSION["par"]+1) . ")",
	                  "inc" => "Novo Inciso (" . NumToRomano($_SESSION["inc"]+1) . ")",
	                  "ali" => "Nova Alnea (" . NumToLetra($_SESSION["ali"]+1) . ")",
	                  "itm" => "Novo Item (" . ($_SESSION["itm"]+1) . ".)");
	echo $erro_texto;
	echo "<INPUT TYPE=\"radio\" NAME=\"radProxElem\" VALUE=\"$VALUE\"" . ((($_REQUEST["radProxElem"] == $VALUE) AND $GLOBALS["erro_texto"]) ? " CHECKED" : "") .">" . $captions[$VALUE] . "<BR>\n";	
}

// Se est cadastrando ttulo de um Ttulo
	if (($_SESSION["tit"] != 0) and ($_SESSION["cap"] == 0) and ($_SESSION["art"] == 0)) {
// pode ir para Captulo ou Artigo
		echo $prox;
		insere_opcao("cap");
		insere_opcao("art");
	}
	
// Se est cadastrando o ttulo de um Captulo
	elseif (($_SESSION["cap"] != 0) and ($_SESSION["ses"] == 0) and ($_SESSION["art"] == 0)) {
// pode ir para Seo ou Artigo
		echo $prox;
		insere_opcao("ses");
		insere_opcao("art");
	}
// Se est cadastrando o ttulo de uma Seo
	elseif (($_SESSION["ses"] != 0) and ($_SESSION["sub"] == 0) and ($_SESSION["art"] == 0)) {
// pode ir para Sub-seo ou Artigo
		echo $prox;
		insere_opcao("sub");
		insere_opcao("art");
	}
// Se est cadastrando o ttulo de uma Sub-Seo
	elseif (($_SESSION["sub"] != 0) and ($_SESSION["art"] == 0)) {
// obrigatoriamente vai para artigo
		echo "	<INPUT TYPE=\"hidden\" NAME=\"radProxElem\" VALUE=\"art\">";
	}
// Se est cadastrando o caput de um Artigo
	elseif (($_SESSION["art"] != 0) and ($_SESSION["par"] == 0) and ($_SESSION["inc"] == 0) and ($_SESSION["ali"] == 0) and ($_SESSION["itm"] == 0)) {
// pode ir para Artigo, Paragrafo, Inciso, Alinea, Sub-Seo, Seo, Capitulo e Ttulo
		echo $prox;
		insere_opcao("art");
		insere_opcao("par");
		insere_opcao("inc");
		insere_opcao("ali");
		if ($_SESSION["tit"] != 0)
			insere_opcao("tit");
		if ($_SESSION["cap"] != 0) {
			insere_opcao("cap");
			if ($_SESSION["ses"] != 0) {
				insere_opcao("ses");
				if ($_SESSION["sub"] != 0) 
					insere_opcao("sub");
			}
		}
	}
//	Se est cadastrando um pargrafo
	elseif (($_SESSION["par"] != 0) and ($_SESSION["inc"] == 0) and ($_SESSION["ali"] == 0) and ($_SESSION["itm"] == 0)) {
// pode ir para Artigo, Paragrafo, Inciso, Alinea, Sub-Seo, Seo, Capitulo e Ttulo
		echo $prox;
		insere_opcao("art");
		insere_opcao("par");
		insere_opcao("inc");
		insere_opcao("ali");
		if ($_SESSION["tit"] != 0)
			insere_opcao("tit");
		if ($_SESSION["cap"] != 0) {
			insere_opcao("cap");
			if ($_SESSION["ses"] != 0) {
				insere_opcao("ses");
				if ($_SESSION["sub"] != 0) 
					insere_opcao("sub");
			}
		}
	}

// Se est cadastrando o texto de um Inciso
	elseif (($_SESSION["inc"] != 0) and ($_SESSION["ali"] == 0) and ($_SESSION["itm"] == 0)) {
		echo $prox;
		insere_opcao("art");
		insere_opcao("par");
		insere_opcao("inc");
		insere_opcao("ali");
		if ($_SESSION["tit"] != 0)
			insere_opcao("tit");
		if ($_SESSION["cap"] != 0) {
			insere_opcao("cap");
			if ($_SESSION["ses"] != 0) {
				insere_opcao("ses");
				if ($_SESSION["sub"] != 0) 
					insere_opcao("sub");
			}
		}
	}
	// Se est cadastrando o texto de uma Alnea
	elseif (($_SESSION["ali"] != 0) and ($_SESSION["itm"] == 0)) {
		echo $prox;
		insere_opcao("art");
		insere_opcao("par");
		insere_opcao("inc");
		insere_opcao("ali");
		insere_opcao("itm");
		if ($_SESSION["tit"] != 0)
			insere_opcao("tit");
		if ($_SESSION["cap"] != 0) {
			insere_opcao("cap");
			if ($_SESSION["ses"] != 0) {
				insere_opcao("ses");
				if ($_SESSION["sub"] != 0) 
					insere_opcao("sub");
			}
		}
	}
	// Se est cadastrando o texto de um Item
	elseif ($_SESSION["itm"] != 0) {
		echo $prox;
		insere_opcao("art");
		insere_opcao("par");
		insere_opcao("inc");
		insere_opcao("ali");
		insere_opcao("itm");
		if ($_SESSION["tit"] != 0)
			insere_opcao("tit");
		if ($_SESSION["cap"] != 0) {
			insere_opcao("cap");
			if ($_SESSION["ses"] != 0) {
				insere_opcao("ses");
				if ($_SESSION["sub"] != 0) 
					insere_opcao("sub");
			}
		}
	}
?>
	</P>
	<p><INPUT style="FONT-FAMILY: Verdana" type="submit" value="OK" name="btnSubmit"></P>
</form>
<? 
	include ROOT_TEMPLATE . "rodape.php" 
?>
</FONT>
</body>
</html>
