<?	/*  Esse .php contem as funcoes necessarias para a maquina de inferencia do sistema especialista
	funcionar corretamente...
	Desenvolvida por: Equipe Brald Planet Ltda.
	Data: 10/2004 ... (mais ou menos)..       ^_^x
	*/

	require_once "{$_SERVER["DOCUMENT_ROOT"]}/phpsysleg/global.php";
	require_once ROOT_CLASSES . "cl_regras.php";
	require_once ROOT_CLASSES . "cl_declaracao.php";

	/*essa funo contem os operadores e suas respectivas prioridades...
	chega por parametro o operando e retorna a sua prioridade
	^_^x   ...*/
	function Prioridade ($priorid){
		//define o vetor que tera as prioridades..
		$vPri = array();
		//nesse vetor o indice sera o operador e o conteudo sera a sua prioridade..
		$vPri = array('OU' => 0, 'E' => 1, 'NO' => 2, ')' => 3, '(' => 4, 'VERDADEIRO' => 30, 'FALSO' => 31, 'INDEFINIDO' => 32);
		//retorna a respectiva prioridade...
		return($vPri[$priorid]);
	}

	/* essa funcao pega a "parte if" da regra e joga num vetor ontem cada possio do
	vetor tera um codigo da "parte if", e se essa parte for um operador jah sera trocado
	pela sua prioridade usando a funo "Prioridade()"
	^_^x    */
	function  TransformarItemsEmCodigo($ParteIFTexto){
		/*essa funo explode fragmenta a string enviada pelo caracter especificado
		jogando num vetor*/
		$vExpr = explode(" ", $ParteIFTexto);
		/*essa funcao roda o vetor inteiro jogando seu conteudo na variavel $value*/
		foreach ($vExpr as $idx => $value){
		/*se o valor for menor q 300 quer dizer q eh operando entaum substitui pela
		sua respectiva prioridade*/
			if ($value < 300)
				$vExpr[$idx] = Prioridade($value);
		}
		return($vExpr);
	}

	/*Essa eh a funo da Posfixa..    ela pega o vetor que jah esta transformado em codigo
	e faz a posfixa em cima dele..
	^_^x      */
	function PosFixa($vetor, $memoria_trabalho) {
        /*vetor que vai conter a posfixa*/
		$vNumero = array();
		/*vetor que vai coner os operandos, depois serah destruido...*/
		$vOperador = array();
        /*roda o vetor em codigo e joga o conteudo na variavel $value*/
		foreach ($vetor as $idx => $value) {
			/*se o valor for menor que 300 entaum eh operador*/
			if ($value < 300) {
				/*se for ")" entao...*/
				if ($value == 3) {
					$cont = count($vOperador) - 1;
					/*vai ate achar um parentes abrindo "("*/
					while ($vOperador[$cont] != 4){
    					/*joga no vetor vNumero os operandos ateh que encontre um "("...*/
						array_push($vNumero, $vOperador[$cont]);
						/*apaga do vetor vOperador o conteudo que foi passado para o vetor vNumero*/
						unset($vOperador[$cont]);
						$cont--;
					}
					/*apaga do vetor vOperador o conteudo que foi passado para o vetor vNumero*/
					unset($vOperador[$cont]);
				}
    			/*se tiver conteudo no vetor vOperando e a prioridade do value for menor q o ultimo conteudo
    			do vetor vOperador e o valor do vOperador na ultima possio for diferente de "("*/
				elseif ((count($vOperador) > 0) and ($value < $vOperador[count($vOperador)]) and ($vOperador[count($vOperador)] != 4)){
					$cont = count($vOperador) -1;
					/*vai ate achar um parentes abrindo "("*/
					while ($vOperador[$cont] != 4){
						/*joga no vetor vNumero os operandos ateh que encontre um "("...*/
						array_push($vNumero, $vOperador[$cont]);
						$cont--;
					}
					/*joga no vetor vOperador  o value*/
					array_push($vOperador, $value);
				}
                /*se naum for nenhum dos anterioes entaum...*/
				else {
					/*joga no vetor vOperador  o value*/
					array_push($vOperador, $value);
				}
			}
			/*se for numero entaum...*/
			else {
				/* adiciona ao final do vetor numero..*/
				array_push($vNumero,$value);
			}
			$vOperadorReoganizado = array();
			//Inicia o vOperador do 0 novamente
			foreach ($vOperador as $operador)
				array_push($vOperadorReoganizado, $operador);
			$vOperador = $vOperadorReoganizado;
			unset($vOperadorReoganizado);
		}
		/*esse loop serve para verificar e substituir se existir o valor da declaracao pelo seu
		valor  na memoria de trabalho..*/
		foreach ($vNumero as $idx => $value){
			/*substitui declaracao se existir valor na memoria de trabalho*/
			$vNumero[$idx] = SubstituiDeclaracaoPorValorMemoriaTrabalho($value,$memoria_trabalho);
		}
		return($vNumero);
	}

	/* esta funcao pega o indice do operador que esta antes do que foi mandado
	^_^x     ....*/
	function PegaOperandoAcima ($vet, $idx){
		for ($i= $idx-1;$i >= 0; $i--)
			if (($vet[$i] > 300) or ($vet[$i] == 30) or ($vet[$i] == 31) or ($vet[$i] < -300))
				break;
		return($i);
	}

	/*essa funcao verifica se o numero anterior ao do indice q foi mandado do vetor eh declaracao e se o
	anterior do anterior tambem eh declaracao..
	^_^x     .......*/
	function Verificacao($vet, $idx){
		if ((($vet[$idx-1] == 30) or ($vet[$idx-1] == 31) or ($vet[$idx-1] > 300) or ($vet[$idx-1] < -300)) and (($vet[$idx-2] == 30) or ($vet[$idx-2] == 31) or ($vet[$idx-2] > 300)or ($vet[$idx-2] < -300)))
			return(1);
		else
			return(0);


	}

	/*essa funcao substitui a declaracao por TRUE ou FALSE se j foi para a memoria de trabalho
	mais se no foi ainda volta a propria declaracao
	^_^x    ......*/
	function SubstituiDeclaracaoPorValorMemoriaTrabalho($dec,$vMemoriaTrabalho){
		if ($vMemoriaTrabalho[$dec]) {
			return($vMemoriaTrabalho[$dec]);
		}else
		return($dec);
	}

	/* essa funcao pega o vetor com a posfixa e simplifica, tirando o q naum eh necessario perguntar
	ao usuario...
	^_^x    ........*/
	function Simplificadora($vPosFixa){
		/*esse indice serve para quanto a variavel for negativa, dai junta a declaracao com
		o 2 (codigo da negativa), para simplificar..  se naum for simplificado volta para
		o valor q estava antes..*/
		 $IndiceNegativo = -30000;
		$vNumerosNegativos = array();

		/*esse loop serve para ver se tem o 2 antes, e se tiver inverte o valor da
		declaracao se ela for 30 ou 31*/
		foreach ($vPosFixa as $idx => $value){
				/* se for igual a 2 quer dizer q tem negacao antes*/
				if ($value == 2)
					/*se era True vira False*/
					if ($vPosFixa[$idx-1] == 30){
						$vPosFixa[$idx-1] = 31;
						$vPosFixa[$idx] = -1;
					/*se era False vira True*/
					} elseif ($vPosFixa[$idx-1] == 31){
						$vPosFixa[$idx-1] = 30;
						$vPosFixa[$idx] = -1;
					}
		}

		/*se naum conseguiu anular o dois no loop acima, ele e a declaracao saum
		transformados em um codigo negativo comeando de -30000*/
		foreach ($vPosFixa as $indice => $valor){
			if (($valor == 2) and ($vPosFixa[$indice-1] > 300)){
				$vNumerosNegativos[$IndiceNegativo] = $vPosFixa[$indice-1]." ".$valor;
				$vPosFixa[$indice] = $IndiceNegativo;
				$vPosFixa[$indice-1] = -1;
				$IndiceNegativo--;
			}
		}

		/*aqui roda o vetor da posfixa e pega cada valor..*/
		foreach ($vPosFixa as $idx => $value){
			/*soh entra se o value for um operador*/
			if (($value < 300) and ($value != 30) and ($value != 31)and($value > -300 )) {
				/*pega o indice da primeira declaracao antes do operador em questao...*/
				$posOperando = PegaOperandoAcima($vPosFixa,$idx);
				/*se a operacao for OU faz a operao OR com as duas declaraes anteriores*/
				if (($value == 0)and (Verificacao($vPosFixa,$idx))){
					/* Se uma das declaraes for verdadeira, a operao OR resulta verdadeira*/
					if (($vPosFixa[$posOperando] == 30) or ($vPosFixa[PegaOperandoAcima($vPosFixa, $posOperando)] == 30)){
						$vPosFixa[$idx] = 30; // Substitui o operador por verdadeiro
						// Anula as duas outras declaraes
						$vPosFixa[$posOperando] = -1;
						$vPosFixa[PegaOperandoAcima($vPosFixa, $posOperando)] = -1;
						/* Se as duas declaraes forem falsas*/
					}elseif (($vPosFixa[$posOperando] == 31) and ($vPosFixa[PegaOperandoAcima($vPosFixa, $posOperando)] == 31)){
						$vPosFixa[$idx] = 31; // Substitui o operador por falso
						// Anula as duas outras declaraes
						$vPosFixa[$posOperando] = -1;
						$vPosFixa[PegaOperandoAcima($vPosFixa, $posOperando)] = -1;
					}else{
						// Se a primeira declarao for falsa e a segunda indefinida
						if ($vPosFixa[$posOperando] == 31){
							$vPosFixa[$idx] = $vPosFixa[PegaOperandoAcima($vPosFixa, $posOperando)];
							$vPosFixa[$posOperando] = -1;
							$vPosFixa[PegaOperandoAcima($vPosFixa, $posOperando)] = -1;
						}
						// Se a segunda delcarao for false e a primeira for indefinida
						if ($vPosFixa[PegaOperandoAcima($vPosFixa, $posOperando)] == 31){
							$vPosFixa[$idx] = $vPosFixa[$posOperando];
							$vPosFixa[$posOperando] = -1;
							$vPosFixa[PegaOperandoAcima($vPosFixa, $posOperando)] = -1;
						}
					}
				}
				/*se a operacao for E*/
				if (($value == 1)and (Verificacao($vPosFixa,$idx))){
					if (($vPosFixa[$posOperando] == 30) and ($vPosFixa[PegaOperandoAcima($vPosFixa,$posOperando)] == 30)){ // Se ambas declaraes forem verdadeira, a operao resulta verdadeira
						$vPosFixa[$idx] = 30; // Substitui o operador por verdadeiro
						// Anula as duas outras declaraes
						$vPosFixa[$posOperando] = -1;
						$vPosFixa[PegaOperandoAcima($vPosFixa, $posOperando)] = -1;
					}elseif (($vPosFixa[$posOperando] == 31) or ($vPosFixa[PegaOperandoAcima($vPosFixa,$posOperando)] == 31)){ // Se as duas declaraes forem falsas
						$vPosFixa[$idx] = 31; // Substitui o operador por falso
						// Anula as duas outras declaraes
						$vPosFixa[$posOperando] = -1;
						$vPosFixa[PegaOperandoAcima($vPosFixa, $posOperando)] = -1;
					}else{
						// Se a primaira for verdadeira e a segunda for indefinida
						if ($vPosFixa[$posOperando] == 30) {
							$vPosFixa[$idx] = $vPosFixa[PegaOperandoAcima($vPosFixa, $posOperando)];
							$vPosFixa[$posOperando] = -1;
							$vPosFixa[PegaOperandoAcima($vPosFixa, $posOperando)] = -1;
							//echo("<BR>olha ae mano as paradas....");print_r($vPosFixa);echo("<BR>");
						}
						// Se a segunda for verdadeira e a primeira for indefinida
						if ($vPosFixa[PegaOperandoAcima($vPosFixa, $posOperando)] == 30) {
							$vPosFixa[$idx] = $vPosFixa[$posOperando];
							$vPosFixa[$posOperando] = -1;
							$vPosFixa[PegaOperandoAcima($vPosFixa, $posOperando)] = -1;
						}
					}
				}
			}
		}
		foreach($vPosFixa as $idx => $value){
			if ($vNumerosNegativos[$value])
				$vPosFixa[$idx] = $vNumerosNegativos[$value];
		}
		$vEsseSim = array();
		$aux = array();
		foreach($vPosFixa as $value){
			$aux = explode(" ",$value);
			foreach ($aux as $value2)
				array_push($vEsseSim, $value2);
		}
		$vPosFixa = $vEsseSim;

		/*Agora tem que limpar o vetor dos numeros -1*/
		$vSemMenosUm = array();
		foreach ($vPosFixa as $value)
			if ($value != -1)
				array_push($vSemMenosUm, $value);
		$vPosFixa = $vSemMenosUm;
		unset($vSemMenosUm);
		return($vPosFixa);
	}

	function JuntaDuasDeclaracoesEUmOperador($vSimplificado){
		$vNovo = $vSimplificado;
		$vComIndicesAntigos = array();
		$IndiceNegativo = -301;
        $loopWhile = 1;
		$vVerifica = $vNovo;
        while ($loopWhile){

		foreach($vNovo as $idx => $value){
			if (($value == 0) or ($value == 1)){
				if ((($vNovo[$idx-1] >300) or ($vNovo[$idx-1] < -300) ) and (($vNovo[$idx-2] > 300 or (($vNovo[$idx-2] < -300))))){
                    $vComIndicesAntigos[$IndiceNegativo] = $vNovo[$idx-2]." ".$vNovo[$idx-1]." ".$vNovo[$idx];
					$vNovo[$idx] = $IndiceNegativo;
					$vNovo[$idx-1] = "";
					$vNovo[$idx-2] = "";
					$IndiceNegativo--;
				}
                if (($vNovo[$idx-1] == 2) and (($vNovo[$idx-2] > 300)or($vNovo[$idx-2] < -300)) and (($vNovo[$idx-3] > 300) or ($vNovo[$idx-3] < -300))){
                    $vComIndicesAntigos[$IndiceNegativo] =  $vNovo[$idx-3]." ".$vNovo[$idx-2]." ".$vNovo[$idx-1]." ".$vNovo[$idx];
					$vNovo[$idx] = $IndiceNegativo;
					$vNovo[$idx-1] = "";
					$vNovo[$idx-2] = "";
					$vNovo[$idx-3] = "";
					$IndiceNegativo--;
				}
                if ((($vNovo[$idx-1] >300)or($vNovo[$idx-1] < -300)) and ($vNovo[$idx-2] == 2) and (($vNovo[$idx-3] > 300) or ($vNovo[$idx-3] < -300))){
                    $vComIndicesAntigos[$IndiceNegativo] = $vNovo[$idx-3]." ".$vNovo[$idx-2]." ".$vNovo[$idx-1]." ".$vNovo[$idx];
					$vNovo[$idx] = $IndiceNegativo;
					$vNovo[$idx-1] = "";
					$vNovo[$idx-2] = "";
					$vNovo[$idx-3] = "";
					$IndiceNegativo--;
				}
                if (($vNovo[$idx-1] == 2) and (($vNovo[$idx-2] > 300)or($vNovo[$idx-2] < -300)) and ($vNovo[$idx-3] == 2) and (($vNovo[$idx-4] > 300)or($vNovo[$idx-4] < -300)) ){
                    $vComIndicesAntigos[$IndiceNegativo] = $vNovo[$idx-4]." ".$vNovo[$idx-3]." ".$vNovo[$idx-2]." ".$vNovo[$idx-1]." ".$vNovo[$idx];
					$vNovo[$idx] = $IndiceNegativo;
					$vNovo[$idx-1] = "";
					$vNovo[$idx-2] = "";
					$vNovo[$idx-3] = "";
					$vNovo[$idx-4] = "";
					$IndiceNegativo--;
				}
			}
		}

        	$vSuper = array();
			foreach ($vNovo as $value)
				if ($value != "")
					array_push($vSuper, $value);

        	foreach($vSuper as $indice => $valor){
            	if ($valor == 2){
            		if ($vSuper[$indice-1] == 30){
            			$vSuper[$indice-1] = 31;
            			$vSuper[$indice] = "";
            		}elseif ($vSuper[$indice-1] == 31){
                        $vSuper[$indice-1] = 30;
            			$vSuper[$indice] = "";
            		}
            	}
			}

			$vvv = array();
            foreach ($vSuper as $value)
				if ($value != "")
					array_push($vvv, $value);

			$vSuper = $vvv;
			unset($vvv);

			$vNovo = Simplificadora($vSuper);
    		$vSuper = $vNovo;
			$loop = 1;
			while ($loop){
				$vNovo = Simplificadora($vNovo);
				if ($vNovo != $vSuper){
                    $vSuper = $vNovo;
				}else{
					$loop = 0;
				}
			}

			if ($vNovo == $vVerifica){
				$loopWhile = 0;
			} else {
				$vVerifica = $vNovo;
			}
            if ($loopWhile){
                $loopWhile = 0;
            	foreach ($vNovo as $v)
            		if (($v == 30)or($v == 31)){
            			$loopWhile = 1;
            			break;
					}
            }
		} // fim do while novo
		$loop = 1;

		while ($loop){
            $vVerifica = $vNovo;
        	foreach($vNovo as $idx => $value)
        		if ($vComIndicesAntigos[$value])
        			$vNovo[$idx] = $vComIndicesAntigos[$value];

        	$aux = array();
        	$vEsseSim = array();
        	foreach($vNovo as $value){
        		$aux = explode(" ",$value);
        		foreach ($aux as $value2)
        			array_push($vEsseSim, $value2);
			}
			$vNovo = $vEsseSim;
			unset($vEsseSim);

			if ($vVerifica == $vNovo){
				$loop = 0;
			}
		}

		$vEsseSim = $vNovo;
		return($vEsseSim);
	}

	/*Funcao serve para verificar se a declaracao  primario ou no, se ele for volta nulo
	se no for volta um vetor contendo as regras que contem essa declaracao na parte Entao*/
	function VerificaDeclaracaoPrimaria($declaracao){
		$clRegra = new regra;
		$vRegras = $clRegra->LerOcorrenciaEntao($declaracao);
		return($vRegras);
	}


	/*essa funcao serve para fazer as perguntas e as posfixas nas declaraoes que nao
	so primarias e assim em diante...  entendeu??? */
	function PegarTodasAsDeclaracoes($dec_parte_entao){
		$clRegras = new regra;
		$todas_regras = $clRegras->LerOcorrenciaEntao($dec_parte_entao);
		foreach($todas_regras as $regra){
			$parte_if = $regra->expr_se;
			$parte_if_codigo = TransformarItemsEmCodigo($parte_if);
			$vPosFixa = PosFixa($parte_if_codigo,$_SESSION["memoria_trabalho"]);
			$vSimplificado = Simplificadora($vPosFixa);
			$vSimplificado = Simplificadora($vSimplificado);
			$acumulativa = "";
			foreach ($vSimplificado as $idx => $dec_unica){
				if (VerificaDeclaracaoPrimaria($dec_unica)){
					$vSimplificado[$idx] = PegarTodasAsDeclaracoes($dec_unica);
					$acumulativa = $acumulativa." ".$vSimplificado[$idx];
				}
				else{
					$acumulativa = $acumulativa." ".$dec_unica;
				}
			}
		}
		return($acumulativa);

		/* IMPORTANTE:  tem q dar um explode quando chamar essa funo!!!!!*/
	}
?>
