<?
	session_start();
	require "{$_SERVER["DOCUMENT_ROOT"]}/phpsysleg/global.php";
	require ROOT_CLASSES . "cl_palavras.php";
	if ($_REQUEST["txtBusca"]) {

		// Explode a expresso de busca
		$palavras = remove_virgula_e_espacos($_REQUEST["txtBusca"]);
		// Procura nas palavras chave
		// $todas_decs  um array de objetos declaracao, com todas as declaraes vinculadas s palavras chave (inclusive repetidas)
		$todas_decs = array();
		$erro_busca = "";
		foreach ($palavras as $palavra) {
			$clPalavra = new palavra;
			$declaracoesEnc = $clPalavra->LerDeclaracoesPalavra($palavra);
			if ($declaracoesEnc) {
				// Se encontrou declaraes, merge com $todas_decs
				$todas_decs = array_merge($todas_decs, $declaracoesEnc);
			}
		}
		// Se encontrou uma ou mais declaraes
		if ($todas_decs) {
		// Realiza a quantificao de ocorrncias de cada declarao, atrves do seu cdigo.
			// Duplica o array com todas as declaraes para rodar os dois juntos
			$todas_decs2 = $todas_decs;
			// $qtds recebe no ndice n, o nmero de vezes que a declarao cdigo n apareceu na pesquisa
			$qtds = array();
			// Para cada declarao no vetor de todas...
			foreach ($todas_decs as $dec1) {
				// ...se no estiver no qtds...
				if (array_search($dec1->codigo, $qtds) === FALSE) {
					// ...inicializa um contador de ocorrencias...
					$vezes = 0;
					// ... e realiza a contagem, rodando o vetor $todas_decs2
					foreach($todas_decs2 as $dec2) {
						if ($dec2->codigo == $dec1->codigo){
							$vezes++;
						}
					}
					$qtds[$dec1->codigo] = $vezes;
				}
			}
			// Ordena o vetor por ocorrncias
			arsort($qtds,SORT_NUMERIC);
			// Envia o vetor para a sesso
			$_SESSION["qtds"] = $qtds;
			header("Location: pesq_decs.php");
			exit;
		}
		else
			$erro_busca = "Nenhum resultado para a sentena informada.";
	}
	else
		$erro_busca = "Digite uma sentena para busca.";
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<HTML>
<HEAD>
<TITLE>Sysleg - Consulta</TITLE>
<META NAME="GENERATOR" CONTENT="MAX's HTML Beauty++ 2004">
</HEAD>

<BODY onLoad="javascript:document.frmBusca.txtBusca.focus();">
<?
	include ROOT_TEMPLATE . "topo.php";
	include ROOT_TEMPLATE . "menuvazio.php";
?>
<P><CENTER><FONT SIZE="2">Digite o assunto a ser pesquisado</FONT></P>
<FORM ACTION="index.php" METHOD="GET" NAME="frmBusca">
<P><?
	if ($erro_busca and (isset($_REQUEST["txtBusca"])))
		echo "<FONT COLOR=\"#FF0000\" SIZE=2>$erro_busca</FONT>\n";
?><CENTER><INPUT TYPE="text" NAME="txtBusca" SIZE=50>
<INPUT TYPE="submit" NAME="btnSubmit" value="Consultar"></font></p>
</FORM>
<P><font size="1">Exemplos: "trancamento curso", ou "segunda chamada".</font></P>
<P><BR><BR><a href="../visualizacao/seleciona.php">Visualizar resolues</a></P>
<?
	include ROOT_TEMPLATE . "rodape.php";
?>
</BODY>
</HTML>
