<?

	require "{$_SERVER["DOCUMENT_ROOT"]}/phpsysleg/global.php";
	require ROOT_CLASSES . "cl_declaracao.php";
	require ROOT_CLASSES . "cl_regras.php";

	if ($_REQUEST["btnCancelar"]) {
		header("Location:regras.php");
		exit;
	}

	// Processar as regras
if ($_REQUEST["btnSubmit"]) {
	if ($_REQUEST["txtSe"]) {
		// Remover espaos
		$expressoes = explode(" ", $_REQUEST["txtSe"]);

        // Remove os indices com vazio
		foreach ($expressoes as $idx => $expressao)
			if ($expressao == "")
				unset($expressoes[$idx]);

		/* Neste ponto $expressoes  um array com (, ), E, OU, NO e os nmeros das declaraes
         P.e.: para SE = ""(  250 E 251  )"
         		Array ( [0] => (
        				[2] => 250
        				[3] => E
        				[4] => 251
        				[6] => )
        			  ) */

		// Verifica as declaraes
		$declaracoesSe = "";
		foreach ($expressoes as $idx => $expressao) {
			if ($erro_regra_se)
				break;
			switch ($expressao) {
			case "(":
				break;
			case "E":
				break;
			case "OU":
				break;
			case "NO":
				break;
			case ")":
				break;
			default : // Se no for operador,  declarao
				// Se a expresso no for 0 (string convertida para int)
				if ((int)$expressao == 0) {
					$erro_regra_se = "Erro na expresso IF em $expressao";
				}
				else
				{
				// Verifica se  declarao vlida
					$clDeclaracao = new declaracao;
					$clDeclaracao->codigo = $expressao;
					$clDeclaracao->Ler();
					if (!($clDeclaracao->afirmativa)) // Se existir em BD, afirmativa vai estar atribuda
						$erro_regra_se = "Erro na expresso IF em $expressao: declarao no cadastrada";
//					elseif ($clDeclaracao->perguntavel != "S")
//						$erro_regra_se = "Todas as declaraes da expresso SE devem ser perguntveis";
					else {
//						$declaracoesSe[$idx] = $expressao;
						// Constroi uma string, separada com vrgulas, com as declaraes SE (para ocorrencia_se)
						$declaracoesSe .= $expressao . ",";
						$erro_regra_se = "";
					}
					unset($clDeclaracao);
					break;
				}
			}
		}
		// Se for vlida, reconstri a string devidamente padronizada
		if (!($erro_regra_se)) {
			$regraSe = "";
			foreach ($expressoes as $expressao)
				$regraSe .= $expressao . " ";
		}
	}
	else
		$erro_regra_se = "Informe a expreso SE corretamente";

		// Autentica a ENTO que deve ser vlida
	if ($_REQUEST["txtEntao"]) {
		$regraEntao = trim($_REQUEST["txtEntao"]);
		$clDeclaracao = new declaracao;
		$clDeclaracao->codigo = $regraEntao;
		$clDeclaracao->Ler();
		if (!($clDeclaracao->codigo))
			$erro_regra_entao = "Erro na expresso ENTO: $regraEntao no  vlido";
		else
			$erro_regra_entao = "";
	}
	else
		$erro_regra_entao = "Informe a expreso ENTO corretamente";

	if ((!($erro_regra_se)) AND (!($erro_regra_entao))) {
	// Sem erros, procede salvamento.
		Transacao('BEGIN');
		// Altera a regra
		$clRegra = new regra;
		$clRegra->codigo = $_REQUEST["regra"];
		$clRegra->expr_se = "( " . trim($regraSe) . " )";
		$clRegra->expr_entao = "( " . $regraEntao . " )";
		$altera_regra = $clRegra->Alterar();
		// Exclui todas as ocorrncias da parte SE registradas
		$excluir_ocse = $clRegra->ExcluirOcorrenciaSe($clRegra->codigo);
		// Exclui todas as ocorrncias da parte ENTO registradas
		$excluir_ocentao = $clRegra->ExcluirOcorrenciaEntao($clRegra->codigo);
		// Salva as novas ocorrncias de declaraes na parte SE
		$declaracoesSe = explode(",", $declaracoesSe);
		foreach ($declaracoesSe as $declaracaoSe) {
			if ($declaracaoSe) {
				$salvar_oc_se = $clRegra->SalvarOcorrenciaSe($clRegra->codigo, $declaracaoSe);
				if ($salvar_oc_se === TRUE)
					continue;
				else
					break;
			}
		}
		// Salva a ocorrncia da declarao na parte ENTO
		$salvar_oc_entao = $clRegra->SalvarOcorrenciaEntao($clRegra->codigo, $regraEntao);

		// Commit apenas se no teve erro em nenhum dos salvamentos.
		if ($altera_regra === TRUE)
			if ($excluir_ocse === TRUE)
				if ($excluir_ocentao === TRUE)
					if ($salvar_oc_se === TRUE)
						if ($salvar_oc_entao === TRUE) {
							Transacao('COMMIT');
							header("Location:regras.php");
							exit;
						}
						else
							$erro_salvamento = "Erro no salvamento das ocorrncias ENTO. $salvar_oc_entao. Operao no executada!";
					else
						$erro_salvamento = "Erro no salvamento das ocorrncias SE. $salvar_oc_se. Operao no executada!";
				else
					$erro_salvamento = "Erro na excluso das ocorrncias ENTO. $excluir_ocentao. Operao no executada!";
			else
				$erro_salvamento = "Erro no salvamento das ocorrncias SE. $excluir_ocse. Operao no executada!";
		else
			$erro_salvamento = "Erro na alterao das regras. $altera_regra. Operao no executada!";

		if ($erro_salvamento) {
			Transacao('ROLLBACK');
			echo $erro_salvamento;
		}


	}
}
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<HTML>
<HEAD>
<TITLE>Sysleg - Regras</TITLE>
<META NAME="GENERATOR" CONTENT="MAX's HTML Beauty++ 2004">
</HEAD>

<FRAMESET ROWS="80, *" FRAMEBORDER="0">
	<FRAME SRC="http://<? echo $_SERVER["HTTP_HOST"]; ?>/phpsysleg/template/topo.php" SCROLLING="no">
	<FRAMESET COLS="40%, 60%" FRAMEBORDER="0">
		<FRAME SRC="regras_altera_expr.php<? echo "?regra={$_REQUEST["regra"]}&txtSe={$_REQUEST["txtSe"]}&erro_regra_se=$erro_regra_se&txtEntao={$_REQUEST["txtEntao"]}&erro_regra_entao=$erro_regra_entao&erro_salvamento=$erro_salvamento"; ?>" NAME="REGRA" SCROLLING="no">
		<FRAME SRC="regras_altera_decs.php" NAME="DECS" SCROLLING="auto">
	</FRAMESET>
</FRAMESET>

</HTML>
