<?
session_start();

// Seta as constantes de diretrios
// A pasta sysleg deve estar sempre diretamente no diretrio root do servidor.
// Estas constantes so usadas para operaes "require" e "include"
define("ROOT_SYSLEG", $_SERVER["DOCUMENT_ROOT"] . "phpsysleg/");
define("ROOT_ADMIN", ROOT_SYSLEG . "admin/");
define("ROOT_DB", ROOT_SYSLEG . "bd/");
define("ROOT_CLASSES", ROOT_SYSLEG . "classes/");
define("ROOT_TEMPLATE", ROOT_SYSLEG . "template/");
define("ROOT_VISUALIZACAO", ROOT_SYSLEG . "visualizacao/");
define("ROOT_IMAGES", ROOT_SYSLEG . "images/");

// Estas constantes so usadas em links (URL absoluta)
define("URL_SYSLEG", "http://{$_SERVER["HTTP_HOST"]}/phpsysleg/");
define("URL_ADMIN", URL_SYSLEG . "admin/");


// Funes globais
function hierarquia() {
	$item = "";
	$virg = "";
	if ($_SESSION["itm"] <> 0) {
		$item = "Item " . $_SESSION["itm"];
		$virg = ", ";
	}
	if ($_SESSION["ali"] <> 0) {
		$item .= $virg . "Alnea " . NumToLetra($_SESSION["ali"]);
		$virg = ", ";
	}
	if ($_SESSION["inc"] <> 0) {
		$item .= $virg . "Inciso " . NumToRomano($_SESSION["inc"]);
		$virg = ", ";
	}
	if ($_SESSION["par"] <> 0) {
		$item .= $virg . "Pargrafo " . $_SESSION["par"] . "";
		$virg = ", ";
	}
	if ($_SESSION["art"] <> 0) {
		$item .= $virg . "Artigo " . $_SESSION["art"] . "";
		$virg = ", ";
	}
	if ($_SESSION["sub"] <> 0) {
		$item .= $virg . "Sub-seo " . NumToRomano($_SESSION["sub"]);
		$virg = ", ";
	}
	if ($_SESSION["ses"] <> 0) {
		$item .= $virg . "Seo " . NumToRomano($_SESSION["ses"]);
		$virg = ", ";
	}
	if ($_SESSION["cap"] <> 0) {
		$item .= $virg . "Captulo " . NumToRomano($_SESSION["cap"]);
		$virg = ", ";
	}
	if ($_SESSION["tit"] <> 0) {
		$item .= $virg . "Ttulo " . NumToRomano($_SESSION["tit"]);
	}
	$item .= ", {$_SESSION["org"]} {$_SESSION["num"]}/{$_SESSION["ano"]}";
	return $item;
}

function NumToRomano($valor) {
	$romans = array(1 => 'I', 'IV', 'V', 'IX', 'X', 'XL', 'L', 'XC', 'C', 'CD', 'D', 'CM', 'M');
	$arabics = array(1 => 1, 4, 5, 9, 10, 40, 50, 90, 100, 400, 500, 900, 1000);
	$scratch = '';
	for ($i = 13; $i >= 1; $i--) {
    	while ($valor >= $arabics[$i]) {
			$valor = $valor - $arabics[$i];
			$scratch = $scratch . $romans[$i];
		}
	}
	return $scratch;
}

function NumToLetra($val) {
	$letra = chr($val + 96);
	return $letra;
}

function print_vars($obj) {
   $arr = get_object_vars($obj);
   while (list($prop, $val) = each($arr))
       echo "\t$prop = $val\n";
}

function RemoverAcentos($s) {
	// Em iMasters: http://www.imasters.com.br/artigo.php?cn=282&cc=44 @ 05/11/2004
	$s = ereg_replace("[]","a",$s);
	$s = ereg_replace("[]","A",$s);
	$s = ereg_replace("[]","e",$s);
	$s = ereg_replace("[]","E",$s);
	$s = ereg_replace("[]","i",$s);
	$s = ereg_replace("[]","I",$s);
	$s = ereg_replace("[]","o",$s);
	$s = ereg_replace("[]","O",$s);
	$s = ereg_replace("[]","u",$s);
	$s = ereg_replace("[]","U",$s);
	$s = str_replace("","c",$s);
	$s = str_replace("","C",$s);
	$s = ereg_replace('[ ,.?!@#$%&*(){}"]',"",$s);

	return($s);
}

function EspacoSimples($string) {
	return (preg_replace('/\s+/', ' ', $string));
}

function Transacao($acao) {
	include ROOT_DB . "conecta_admin.php";
	$qryRegra = mysql_query($acao);
	if (mysql_errno() == 0)
		return (TRUE);
	else
		return (mysql_error());
}

/*dandandan*/
function remove_virgula_e_espacos($palavra){
    $Palavras_final = array();
   	$vPalavras = remove_virgulas_espacos($palavra);
   foreach ($vPalavras as $palavras_com_espaco){
   	   $aux = explode(" ", $palavras_com_espaco);
       foreach ($aux as $p){
       	   array_push($Palavras_final,$p);
	   }
   }
   return($Palavras_final);
}


function remove_virgulas_espacos($string) {
	// Remove espaos repetidos (2 ou mais juntos)
	$string = EspacoSimples($string);
    // Quebra a string em array, separando as expresses por virgula
	$palavras = explode(",", $string);
	// Efetua o trim em cada palavra.
	foreach ($palavras as $idx => $palavra) {
		$palavras[$idx] = trim($palavra);
		//Caso a palavra ficar vazia, ou restar um espao apenas, remove do array
		if ((!($palavra)) OR ($palavra == " "))
			unset($palavras[$idx]);
	}
	return($palavras);  // Array com as palavras vlidas, com espaos somente entre palavras compostas. P.e., $string "UFPR, conselho pesquisa" retorna ** Array ( 0 => "UFPR", 1 => "conselho pesquisa" ) **
}

function DataExtenso($data) {
    $data = explode("/", $data);
	$vetMes = array(1 => "janeiro",
					2 => "fevereiro",
					3 => "maro",
					4 => "abril",
					5 => "maio",
					6 => "junho",
					7 => "julho",
					8 => "agosto",
					9 => "setembro",
					10 => "outubro",
					11 => "novembro",
					12 => "dezembro");

	return("{$data[0]} de {$vetMes[(int)$data[1]]} de {$data[2]}");
}
?>
