<?
	require "{$_SERVER["DOCUMENT_ROOT"]}/phpsysleg/global.php";
	include ROOT_CLASSES . "cl_elemento.php";

	function FormataTexto($texto) {
		// Substitui as quebras de linha por <BR>
		$texto_ok = nl2br($texto);
		return($texto_ok);
	}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<HTML>
<HEAD>
<TITLE>Sysleg - Administra&ccedil;&atilde;o - Resolu&ccedil;&otilde;es</TITLE>
<META NAME="GENERATOR" CONTENT="MAX's HTML Beauty++ 2004">
</HEAD>

<BODY><?
	include ROOT_TEMPLATE . "topo.php";
	include ROOT_TEMPLATE . "menuvazio.php";
	$clElementos = new elemento;
	$elementos = $clElementos->ElementosResolucao($_REQUEST["org"],$_REQUEST["num"],$_REQUEST["ano"]);
	echo "
<P><H3>RESOLUO {$elementos[0]->resolucao->orgao->sigla} {$elementos[0]->resolucao->num}/{$elementos[0]->resolucao->ano}</H3></P>\n
<TABLE BORDER=0>
	<TR>
		<TD WIDTH=60%></TD>
		<TD><P><I><B>{$elementos[0]->resolucao->finalidade}</B></I></P></DIV>
	</TR>
	<TR>
		<TD COLSPAN=2><P STYLE=\"text-indent: 80px\">{$elementos[0]->resolucao->parag_intro}</P></TD>
	</TR>
</TABLE>\n";

	foreach ($elementos as $elemento) {
		// Se o elemento for ttulo
		if (($elemento->tit != 0) and ($elemento->cap == 0) and ($elemento->art == 0)) {
			echo "<P><H3><CENTER>TTULO " . NumToRomano($elemento->tit) . "<BR>\n";
			echo $elemento->texto . "</CENTER></H3></P>\n";
		}
		elseif (($elemento->cap != 0) and ($elemento->ses == 0) and ($elemento->art == 0)) {
			echo "<P><H4><CENTER>CAPTULO " . NumToRomano($elemento->cap) . "<BR>\n";
			echo $elemento->texto . "</CENTER></H4></P>\n";
		}
		elseif (($elemento->ses != 0) and ($elemento->sub == 0) and ($elemento->art == 0)) {
			echo "<P><H4><CENTER>Seo " . NumToRomano($elemento->ses) . "<BR>\n";
			echo $elemento->texto . "</CENTER></H4></P>\n";
		}
		elseif (($elemento->sub != 0) and ($elemento->art == 0)) {
			echo "<P><H4><CENTER>Sub-Seo " . NumToRomano($elemento->sub) . "<BR>\n";
			echo $elemento->texto . "</CENTER></H4></P>\n";
		}
		elseif (($elemento->art != 0) and ($elemento->par == 0) and ($elemento->inc == 0) and ($elemento->ali == 0) and ($elemento->itm == 0)) {
			echo "<P>Art. {$elemento->art} - {$elemento->texto}</P>\n";
		}
		elseif (($elemento->par != 0) and ($elemento->inc == 0) and ($elemento->ali == 0) and ($elemento->itm == 0)) {
			if ($elemento->EhParagrafoUnico() === TRUE)
				echo "<P>Pargrafo nico - {$elemento->texto}\n";
			else
				echo "<P> {$elemento->par} - " . FormataTexto($elemento->texto) . "\n";
		}
		elseif (($elemento->inc != 0) and ($elemento->ali == 0) and ($elemento->itm == 0)) {
			echo "<P>" . NumToRomano($elemento->inc) . " -	{$elemento->texto}\n";
		}
		elseif (($elemento->ali != 0) and ($elemento->itm == 0)) {
			echo "<P>" . NumToLetra($elemento->ali) . ")	{$elemento->texto}\n";
		}
		elseif ($elemento->itm != 0) {
			echo "<P>" . $elemento->itm . " -	$elemento->texto\n";
		}
		else
			echo "<FONT COLOR=\"#FF0000\" SIZE=\"3\">No sei o que </FONT> ".print_vars($elemento);
	}
	echo "
<P><CENTER>" . DataExtenso($elementos[0]->resolucao->data) . "</CENTER></P>\n
<P><CENTER> {$elementos[0]->resolucao->assinado_por}</CENTER></P>";

	include ROOT_TEMPLATE. "rodape.php" ?>
</BODY>
</HTML>
